## padthv1 0.9.23

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13)

project (padthv1
  VERSION 0.9.23
  DESCRIPTION "an old-school polyphonic additive synthesizer"
  LANGUAGES C CXX)

set (CONFIG_VERSION ${PROJECT_VERSION})
execute_process (
  COMMAND git describe --tags --dirty --abbrev=6
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
  RESULT_VARIABLE GIT_DESCRIBE_RESULT
  OUTPUT_STRIP_TRAILING_WHITESPACE)
if (GIT_DESCRIBE_RESULT EQUAL 0)
  set (VERSION "${GIT_DESCRIBE_OUTPUT}")
  string (REGEX REPLACE "^[^0-9]+" "" VERSION "${VERSION}")
  string (REGEX REPLACE "^1_"      "" VERSION "${VERSION}")
  string (REGEX REPLACE "^[_vV]+"  "" VERSION "${VERSION}")
  string (REGEX REPLACE "-g"   "git." VERSION "${VERSION}")
  string (REGEX REPLACE "[_|-]"   "." VERSION "${VERSION}")
  execute_process (
    COMMAND git rev-parse --abbrev-ref HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
    RESULT_VARIABLE GIT_REVPARSE_RESULT
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (GIT_REVPARSE_RESULT EQUAL 0 AND NOT GIT_REVPARSE_OUTPUT STREQUAL "master")
    set (VERSION "${VERSION} [${GIT_REVPARSE_OUTPUT}]")
  endif ()
else ()
  set (VERSION "${PROJECT_VERSION}")
endif ()

set (PACKAGE_NAME "padthv1")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_BUGREPORT "rncbc@rncbc.org")
set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set (PACKAGE_TARNAME "padthv1")

set (ac_version "${PROJECT_VERSION}")
set (ac_prefix "${CMAKE_INSTALL_PREFIX}")

set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")

if (CONFIG_DEBUG)
  set (CMAKE_BUILD_TYPE "Debug")
endif ()
if (CMAKE_BUILD_TYPE MATCHES "Debug")
  set (CONFIG_DEBUG 1)
endif ()
if (CONFIG_DEBUG)
  set (CONFIG_BUILD_TYPE "debug")
else ()
  set (CONFIG_BUILD_TYPE "release")
endif ()

set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")

include (GNUInstallDirs)
set (CONFIG_BINDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set (CONFIG_LIBDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set (CONFIG_DATADIR "${CONFIG_PREFIX}/${CMAKE_INSTALL_DATADIR}")
set (CONFIG_MANDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_MANDIR}")


# Enable JACK standalone build.
option (CONFIG_JACK "Enable JACK stand-alone build (default=yes)" 1)

# Enable JACK session support.
option (CONFIG_JACK_SESSION "Enable JACK session support (default=yes)" 1)

# Enable JACK MIDI support option.
option (CONFIG_JACK_MIDI "Enable JACK MIDI support (default=yes)" 1)

# Enable ALSA MIDI support option.
option (CONFIG_ALSA_MIDI "Enable ALSA MIDI support (default=yes)" 1)

# Enable LV2 plugin build.
option (CONFIG_LV2 "Enable LV2 plug-in build (default=yes)" 1)

if (WIN32)
  option (CONFIG_LV2_UI_WINDOWS "Enable LV2 plug-in Windows UI support (default=yes)" 1)
  # Windows install target path.
  set (CONFIG_WINDOWS_LV2_PATH "$ENV{SYSTEMDRIVE}/Program Files/Common Files/LV2" CACHE STRING "Specify Windows LV2 install path")
else ()
  option (CONFIG_LV2_UI_X11 "Enable LV2 plug-in X11 UI support (default=yes)" 1)
endif ()

option (CONFIG_LV2_UI_EXTERNAL "Enable LV2 plug-in External UI support (default=yes)" 1)

option (CONFIG_LV2_UI_IDLE "Enable LV2 UI Idle interface support (default=yes)" 1)

option (CONFIG_LV2_UI_SHOW "Enable LV2 UI Show interface support (default=yes)" 1)

option (CONFIG_LV2_UI_RESIZE "Enable LV2 UI Resize interface support (default=yes)" 1)

option (CONFIG_LV2_PROGRAMS "Enable LV2 plug-in Programs support (default=yes)" 1)

option (CONFIG_LV2_PATCH "Enable LV2 plug-in Patch support (default=yes)" 1)

option (CONFIG_LV2_PORT_EVENT "Enable LV2 plug-in Port-event support (EXPERIMENTAL) (default=yes)" 1)


# Enable liblo availability.
option (CONFIG_LIBLO "Enable liblo interface (default=yes)" 1)

# Enable NSM support.
option (CONFIG_NSM "Enable NSM support (default=yes)" 1)


# Enable Qt6 build preference.
option (CONFIG_QT6 "Enable Qt6 build (default=yes)" 1)


# Fix for new CMAKE_REQUIRED_LIBRARIES policy.
if (POLICY CMP0075)
  cmake_policy (SET CMP0075 NEW)
endif ()

# Fix for CXX_VISIBILITY_PRESET policy.
if (POLICY CMP0063)
  cmake_policy (SET CMP0063 NEW)
  set (CMAKE_CXX_VISIBILITY_PRESET hidden)
  set (CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif ()

# Check for Qt...
if (CONFIG_QT6)
  find_package (Qt6 QUIET)
  if (NOT Qt6_FOUND)
    set (CONFIG_QT6 0)
  endif ()
endif ()

if (CONFIG_QT6)
  find_package (QT QUIET NAMES Qt6)
else ()
  find_package (QT QUIET NAMES Qt5)
endif ()

find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)

#find_package (Qt${QT_VERSION_MAJOR}LinguistTools)

include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckIncludeFileCXX)
include (CheckFunctionExists)
include (CheckLibraryExists)

# Make sure we get some subtle optimizations out there...
add_compile_options (-ffast-math)

# Checks for header files.
if (UNIX AND NOT APPLE)
  check_include_files ("fcntl.h;unistd.h;signal.h" HAVE_SIGNAL_H)
endif ()


# Find package modules
include (FindPkgConfig)

# Check for FFTW3 libraries.
pkg_check_modules (FFTW3 REQUIRED IMPORTED_TARGET fftw3f)
if (FFTW3_FOUND)
  set (CONFIG_FFTW3 1)
else ()
  message (FATAL_ERROR "*** FFTW3 library not found.")
  set (CONFIG_FFTW3 0)
endif ()

# Check for JACK libraries.
if (CONFIG_JACK)
  pkg_check_modules (JACK IMPORTED_TARGET jack>=0.100.0)
  if (JACK_FOUND)
    find_library (JACK_LIBRARY NAMES ${JACK_LIBRARIES} HINTS ${JACK_LIBDIR})
  endif ()
  if (JACK_LIBRARY)
    set (CONFIG_JACK 1)
    set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
    # Check for JACK MIDI headers availability.
    if (CONFIG_JACK_MIDI)
      check_include_file (jack/midiport.h HAVE_JACK_MIDIPORT_H)
      if (NOT HAVE_JACK_MIDIPORT_H)
        set (CONFIG_JACK_MIDI 0)
      endif ()
    endif ()
    # Check for JACK session headers availability.
    if (CONFIG_JACK_SESSION)
      check_include_file (jack/session.h HAVE_JACK_SESSION_H)
      if (NOT HAVE_JACK_SESSION_H)
        set (CONFIG_JACK_SESSION 0)
      endif ()
    endif ()
    # Check for JACK session event callback availability.
    if (CONFIG_JACK_SESSION)
      check_function_exists (jack_set_session_callback CONFIG_JACK_SESSION)
    endif ()
    # Check for ALSA libraries.
    if (CONFIG_ALSA_MIDI)
      pkg_check_modules (ALSA IMPORTED_TARGET alsa)
      if (ALSA_FOUND)
        find_library (ALSA_LIBRARY NAMES ${ALSA_LIBRARIES} HINTS ${ALSA_LIBDIR})
      endif ()
      if (ALSA_LIBRARY)
        set (CONFIG_ALSA_MIDI 1)
       #set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
      else ()
        message (WARNING "*** ALSA library not found.")
      endif ()
    endif ()
  else ()
    message (WARNING "*** JACK library not found.")
    set (CONFIG_JACK 0)
  endif ()
endif ()

if (NOT CONFIG_JACK)
  set (CONFIG_JACK_SESSION 0)
  set (CONFIG_JACK_MIDI 0)
  set (CONFIG_ALSA_MIDI 0)
  set (CONFIG_LIBLO 0)
  set (CONFIG_NSM 0)
endif ()

# Check for LIBLO libraries.
if (CONFIG_LIBLO)
  pkg_check_modules (LIBLO IMPORTED_TARGET liblo)
  if (NOT LIBLO_FOUND)
    message (WARNING "*** LIBLO library not found.")
    set (CONFIG_LIBLO 0)
  endif ()
endif ()

# Check for LV2 support.
if (CONFIG_LV2)
  pkg_check_modules (LV2 lv2)
  if (LV2_FOUND)
    include_directories (${LV2_INCLUDE_DIRS})
    # Check for LV2 Atom support.
    check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
    if (NOT HAVE_LV2_ATOM_H)
      set (CONFIG_LV2_ATOM 0)
    else ()
      set (CONFIG_LV2_ATOM 1)
    endif ()
    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
    # Check for LV2 UI support.
    check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
    if (NOT HAVE_LV2_UI_H)
      set (CONFIG_LV2_UI 0)
    else ()
      set (CONFIG_LV2_UI 1)
    endif ()
    if (NOT CONFIG_LV2_UI)
      set (CONFIG_LV2_UI_X11 0)
      set (CONFIG_LV2_UI_WINDOWS 0)
      set (CONFIG_LV2_UI_EXTERNAL 0)
      set (CONFIG_LV2_UI_IDLE 0)
      set (CONFIG_LV2_UI_SHOW 0)
      set (CONFIG_LV2_UI_RESIZE 0)
    endif ()
  else ()
    message (WARNING "*** LV2 SDK not found.")
    set (CONFIG_LV2 0)
  endif ()
endif ()

# Check for LV2 headers.
if (CONFIG_LV2)
  set (LV2_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/lv2)
  set (CMAKE_REQUIRED_INCLUDES "${LV2_INCLUDES};${CMAKE_REQUIRED_INCLUDES}")
  include_directories (${LV2_INCLUDES})
else ()
  set (CONFIG_LV2_UI_X11 0)
  set (CONFIG_LV2_UI_WINDOWS 0)
  set (CONFIG_LV2_UI_EXTERNAL 0)
  set (CONFIG_LV2_UI_IDLE 0)
  set (CONFIG_LV2_UI_SHOW 0)
  set (CONFIG_LV2_UI_RESIZE 0)
  set (CONFIG_LV2_PROGRAMS 0)
  set (CONFIG_LV2_PATCH 0)
  set (CONFIG_LV2_PORT_EVENT 0)
endif ()

if (CONFIG_LV2_UI_EXTERNAL)
  check_include_file (lv2_external_ui.h HAVE_LV2_EXTERNAL_UI_H)
  if (NOT HAVE_LV2_EXTERNAL_UI_H)
    set (CONFIG_LV2_UI_EXTERNAL 0)
  endif ()
endif ()

if (CONFIG_LV2_PROGRAMS)
  check_include_file (lv2_programs.h HAVE_LV2_PROGRAMS_H)
  if (NOT HAVE_LV2_PROGRAMS_H)
    set (CONFIG_LV2_PROGRAMS 0)
  endif ()
endif ()

if (CONFIG_LV2_PATCH)
  check_include_file (lv2/lv2plug.in/ns/ext/patch/patch.h HAVE_LV2_PATCH_H)
  if (NOT HAVE_LV2_PATCH_H)
    set (CONFIG_LV2_PATCH 0)
  endif ()
endif ()


add_subdirectory (src)


configure_file (padthv1.spec.in padthv1.spec IMMEDIATE @ONLY)

install (FILES padthv1.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install (FILES padthv1.fr.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME padthv1.1)

# Configuration status
macro (SHOW_OPTION text value)
  if (${value})
    message ("${text}: yes")
  else ()
    message ("${text}: no")
  endif ()
endmacro ()


message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION} (Qt ${QT_VERSION})")
message   ("\n  Build target . . . . . . . . . . . . . . . . . . .: ${CONFIG_BUILD_TYPE}\n")
show_option ("  JACK stand-alone build . . . . . . . . . . . . . ." CONFIG_JACK)
show_option ("  JACK session support . . . . . . . . . . . . . . ." CONFIG_JACK_SESSION)
show_option ("  JACK MIDI support  . . . . . . . . . . . . . . . ." CONFIG_JACK_MIDI)
show_option ("  ALSA MIDI support  . . . . . . . . . . . . . . . ." CONFIG_ALSA_MIDI)
show_option ("  LV2 plug-in build  . . . . . . . . . . . . . . . ." CONFIG_LV2)
if (WIN32)
show_option ("  LV2 plug-in Windows UI support   . . . . . . . . ." CONFIG_LV2_UI_WINDOWS)
else ()
show_option ("  LV2 plug-in X11 UI support   . . . . . . . . . . ." CONFIG_LV2_UI_X11)
endif ()
show_option ("  LV2 plug-in External UI support  . . . . . . . . ." CONFIG_LV2_UI_EXTERNAL)
show_option ("  LV2 plug-in UI Idle interface support  . . . . . ." CONFIG_LV2_UI_IDLE)
show_option ("  LV2 plug-in UI Show interface support  . . . . . ." CONFIG_LV2_UI_SHOW)
show_option ("  LV2 plug-in UI Resize interface support  . . . . ." CONFIG_LV2_UI_RESIZE)
show_option ("  LV2 plug-in Programs support . . . . . . . . . . ." CONFIG_LV2_PROGRAMS)
show_option ("  LV2 plug-in Patch support  . . . . . . . . . . . ." CONFIG_LV2_PATCH)
show_option ("  LV2 plug-in Port-event support (EXPERIMENTAL)  . ." CONFIG_LV2_PORT_EVENT)
show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)
show_option ("  Non Session Management (NSM) support . . . . . . ." CONFIG_NSM)
message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}")
message   ("\nNow type 'make', followed by 'make install' as root.\n")

=== src/CMakeLists.txt ===
# project (padthv1)

set (CMAKE_INCLUDE_CURRENT_DIR ON)

set (CMAKE_AUTOUIC ON)
set (CMAKE_AUTOMOC ON)
set (CMAKE_AUTORCC ON)

if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
  file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
endif ()
configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set (HEADERS
  padthv1.h
  padthv1_sample.h
  padthv1_config.h
  padthv1_filter.h
  padthv1_formant.h
  padthv1_wave.h
  padthv1_ramp.h
  padthv1_list.h
  padthv1_fx.h
  padthv1_reverb.h
  padthv1_param.h
  padthv1_sched.h
  padthv1_tuning.h
  padthv1_programs.h
  padthv1_controls.h
)

set (SOURCES
  padthv1.cpp
  padthv1_sample.cpp
  padthv1_config.cpp
  padthv1_formant.cpp
  padthv1_wave.cpp
  padthv1_param.cpp
  padthv1_sched.cpp
  padthv1_tuning.cpp
  padthv1_programs.cpp
  padthv1_controls.cpp
)


set (HEADERS_UI
  padthv1_ui.h
  padthv1widget.h
  padthv1widget_env.h
  padthv1widget_filt.h
  padthv1widget_sample.h
  padthv1widget_wave.h
  padthv1widget_param.h
  padthv1widget_keybd.h
  padthv1widget_preset.h
  padthv1widget_status.h
  padthv1widget_programs.h
  padthv1widget_controls.h
  padthv1widget_control.h
  padthv1widget_palette.h
  padthv1widget_config.h
)

set (SOURCES_UI
  padthv1_ui.cpp
  padthv1widget.cpp
  padthv1widget_env.cpp
  padthv1widget_filt.cpp
  padthv1widget_sample.cpp
  padthv1widget_wave.cpp
  padthv1widget_param.cpp
  padthv1widget_keybd.cpp
  padthv1widget_preset.cpp
  padthv1widget_status.cpp
  padthv1widget_programs.cpp
  padthv1widget_controls.cpp
  padthv1widget_control.cpp
  padthv1widget_palette.cpp
  padthv1widget_config.cpp
)

set (FORMS_UI
  padthv1widget.ui
  padthv1widget_control.ui
  padthv1widget_palette.ui
  padthv1widget_config.ui
)

set (RESOURCES_UI
  padthv1.qrc
)


set (HEADERS_LV2
  padthv1_lv2.h
  padthv1_lv2ui.h
  padthv1widget_lv2.h
)

set (SOURCES_LV2
  padthv1_lv2.cpp
  padthv1_lv2ui.cpp
  padthv1widget_lv2.cpp
)


set (HEADERS_JACK
  padthv1_nsm.h
  padthv1_jack.h
  padthv1widget_jack.h
)

set (SOURCES_JACK
  padthv1_nsm.cpp
  padthv1_jack.cpp
  padthv1widget_jack.cpp
)


add_library (${PROJECT_NAME} STATIC
  ${HEADERS}
  ${SOURCES}
)

add_library (${PROJECT_NAME}_ui STATIC
  ${HEADERS_UI}
  ${SOURCES_UI}
  ${FORMS_UI}
  ${RESOURCES_UI}
)


if (CONFIG_LV2)
  add_library (${PROJECT_NAME}_lv2 MODULE
    ${HEADERS_LV2}
    ${SOURCES_LV2}
  )
endif ()

if (CONFIG_JACK)
  add_executable (${PROJECT_NAME}_jack
    ${HEADERS_JACK}
    ${SOURCES_JACK}
  )
endif ()

set_target_properties (${PROJECT_NAME}    PROPERTIES CXX_STANDARD 17)
set_target_properties (${PROJECT_NAME}_ui PROPERTIES CXX_STANDARD 17)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
  target_compile_options (${PROJECT_NAME}    PRIVATE -fPIC)
  target_compile_options (${PROJECT_NAME}_ui PRIVATE -fPIC)
endif ()

# Add some debugger flags.
if (CONFIG_DEBUG AND CONFIG_JACK AND UNIX AND NOT APPLE)
  target_compile_options (${PROJECT_NAME}_jack PRIVATE -g -fsanitize=address -fno-omit-frame-pointer)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE asan)
endif ()

target_link_libraries (${PROJECT_NAME}    PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Xml)
target_link_libraries (${PROJECT_NAME}_ui PUBLIC Qt${QT_VERSION_MAJOR}::Widgets ${PROJECT_NAME})

if (CONFIG_FFTW3)
  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::FFTW3)
endif ()

if (CONFIG_LV2)
  set_target_properties (${PROJECT_NAME}_lv2 PROPERTIES CXX_STANDARD 17)
  target_link_libraries (${PROJECT_NAME}_lv2 PRIVATE ${PROJECT_NAME}_ui)
  target_include_directories (${PROJECT_NAME}_lv2 PRIVATE ${LV2_INCLUDE_DIRS})
  target_link_directories (${PROJECT_NAME}_lv2 PRIVATE ${LV2_LIBRARY_DIRS})
  target_link_libraries (${PROJECT_NAME}_lv2 PRIVATE ${LV2_LIBRARIES})
  if (UNIX AND NOT APPLE)
    if (NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_lv2  POST_BUILD
        COMMAND strip lib${PROJECT_NAME}_lv2.so)
    endif ()
    if (CONFIG_PREFIX MATCHES $ENV{HOME})
      set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
    else ()
      set (CONFIG_LV2DIR ${CONFIG_LIBDIR}/lv2)
    endif ()
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${PROJECT_NAME}_lv2.so
      RENAME ${PROJECT_NAME}.so
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/manifest.ttl
      ${PROJECT_NAME}.lv2/${PROJECT_NAME}.ttl
      ${PROJECT_NAME}.lv2/${PROJECT_NAME}_ui.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
  endif ()
  if (WIN32)
    target_link_options (${PROJECT_NAME}_lv2 PRIVATE -static-libgcc -static-libstdc++)
    if (NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_lv2  POST_BUILD
        COMMAND strip lib${PROJECT_NAME}_lv2.dll)
    endif ()
    set (CONFIG_LV2DIR ${CONFIG_WINDOWS_LV2_PATH})
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${PROJECT_NAME}_lv2.dll
      RENAME ${PROJECT_NAME}.dll
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/manifest-win32.ttl
      RENAME manifest.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/${PROJECT_NAME}.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/${PROJECT_NAME}_ui-win32.ttl
      RENAME ${PROJECT_NAME}_ui.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
  endif ()
endif ()

if (CONFIG_JACK)
  set_target_properties (${PROJECT_NAME}_jack PROPERTIES CXX_STANDARD 17)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${PROJECT_NAME}_ui)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::JACK)
  if (CONFIG_ALSA_MIDI)
    target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::ALSA)
  endif ()
  if (CONFIG_LIBLO)
    target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::LIBLO)
  endif ()
  if (UNIX AND NOT APPLE)
    if (NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_jack POST_BUILD
        COMMAND strip ${PROJECT_NAME}_jack)
    endif ()
    install (TARGETS ${PROJECT_NAME}_jack RUNTIME
      DESTINATION ${CMAKE_INSTALL_BINDIR})
    install (FILES ${PROJECT_NAME}.desktop
      DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install (FILES images/${PROJECT_NAME}.png
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
    install (FILES images/${PROJECT_NAME}.svg
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install (FILES appdata/${PROJECT_NAME}.appdata.xml
      DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
    install (FILES mimetypes/${PROJECT_NAME}.xml
      DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)
    install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.png
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/mimetypes)
    install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.svg
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/mimetypes)
  endif ()
endif ()

=== debian/changelog ===
padthv1 (0.9.23-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 04 Oct 2021 17:17:31 -0400

padthv1 (0.9.23-1) unstable; urgency=medium

  * New upstream version 0.9.23
  * Bump Standards-Version to 4.6.0
  * debian/rules: Atm debian archive has no qt6, we compile with --disable-qt6

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 22 Aug 2021 23:53:13 +0200

=== debian/control ===
Source: padthv1
Section: sound
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <d_braun@kabelmail.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 debhelper-compat (= 13),
 libtool,
 libx11-dev,
 qtbase5-dev,
 qttools5-dev-tools,
 ladspa-sdk,
 lv2-dev,
 libsndfile1-dev,
 libasound2-dev,
 libjack-dev | libjack-jackd2-dev,
 libfftw3-dev,
 liblo-dev,
Homepage: https://padthv1.sourceforge.io/
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/multimedia-team/padthv1.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/padthv1
Rules-Requires-Root: no

Package: padthv1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 padthv1-common (= ${source:Version}),
Recommends:
 jackd
Description: old-school polyphonic additive synthesizer - standalone app
 padthv1 is an old-school polyphonic additive synthesizer
 with stereo effects. It is provided in both forms
 of a LV2 plugin and a pure stand-alone JACK
 client with JACK-session and both JACK MIDI and ALSA
 MIDI input support.
 .
 This package provides the standalone app.

Package: padthv1-lv2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 padthv1-common (= ${source:Version}),
Provides:
 lv2-plugin
Description: old-school polyphonic additive synthesizer - LV2 plugin
 padthv1 is an old-school polyphonic additive synthesizer
 with stereo effects. It is provided in both forms
 of a LV2 plugin and a pure stand-alone JACK
 client with JACK-session and both JACK MIDI and ALSA
 MIDI input support.
 .
 This package provides the LV2 plugin.

Package: padthv1-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: old-school polyphonic additive synthesizer - common files
 padthv1 is an old-school polyphonic additive synthesizer
 with stereo effects. It is provided in both forms
 of a LV2 plugin and a pure stand-alone JACK
 client with JACK-session and both JACK MIDI and ALSA
 MIDI input support.
 .
 This package provides files shared by both the LV2 plugin and the standalone
 application.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

EXTRA_CONFIGURE_ARGS = \
 --enable-debug \
 --enable-jack \
 --enable-jack-midi \
 --enable-jack-session \
 --enable-lv2 \
 --disable-qt6

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

ifeq ($(DEB_HOST_ARCH_OS),linux)
EXTRA_CONFIGURE_ARGS += --enable-alsa-midi
else
EXTRA_CONFIGURE_ARGS += --disable-alsa-midi
endif

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CONFIGURE_ARGS)

override_dh_auto_install:
	cp $(CURDIR)/padthv1.1 $(CURDIR)/padthv1_jack.1
	cp $(CURDIR)/padthv1.fr.1 $(CURDIR)/padthv1_jack.fr.1
	dh_auto_install
	cp $(CURDIR)/debian/tmp/usr/share/mime/packages/padthv1.xml $(CURDIR)/debian/padthv1-common.sharedmimeinfo

override_dh_clean:
	dh_clean
	rm -f $(CURDIR)/debian/padthv1-common.sharedmimeinfo
	rm -f $(CURDIR)/padthv1_jack.1
	rm -f $(CURDIR)/padthv1_jack.fr.1

## padthv1 0.9.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required (VERSION 3.13)
+cmake_minimum_required (VERSION 3.15)
 
 project (padthv1
-  VERSION 0.9.23
+  VERSION 0.9.24
   DESCRIPTION "an old-school polyphonic additive synthesizer"
   LANGUAGES C CXX)
 
@@ -346,5 +346,4 @@
 show_option ("  LV2 plug-in Port-event support (EXPERIMENTAL)  . ." CONFIG_LV2_PORT_EVENT)
 show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)
 show_option ("  Non Session Management (NSM) support . . . . . . ." CONFIG_NSM)
-message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}")
-message   ("\nNow type 'make', followed by 'make install' as root.\n")
+message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}\n")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
   file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
 endif ()
-configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
+configure_file (config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
 set (HEADERS
   padthv1.h
@@ -227,13 +227,13 @@
     endif ()
     install (TARGETS ${PROJECT_NAME}_jack RUNTIME
       DESTINATION ${CMAKE_INSTALL_BINDIR})
-    install (FILES ${PROJECT_NAME}.desktop
+    install (FILES org.rncbc.${PROJECT_NAME}.desktop
       DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
     install (FILES images/${PROJECT_NAME}.png
       DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
     install (FILES images/${PROJECT_NAME}.svg
       DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-    install (FILES appdata/${PROJECT_NAME}.appdata.xml
+    install (FILES appdata/org.rncbc.${PROJECT_NAME}.xml
       DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
     install (FILES mimetypes/${PROJECT_NAME}.xml
       DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)

=== debian/changelog ===
padthv1 (0.9.24-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 18 Jan 2022 00:53:28 -0500

padthv1 (0.9.24-1) unstable; urgency=medium

  * New upstream version 0.9.24
  * Build with cmake, drop obsolete patches
  * Update d/copyright years
  * The Appdata file has been renamed
  * The desktop file name has changed
  * Update d/not-installed

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 16 Jan 2022 22:57:31 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
  Dennis Braun <d_braun@kabelmail.de>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- libtool,
  libx11-dev,
  qtbase5-dev,
  qttools5-dev-tools,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH_OS),linux)
 CMAKE_OPTS = -DCONFIG_ALSA_MIDI=ON
else
 CMAKE_OPTS = -DCONFIG_ALSA_MIDI=OFF
endif

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_install:
	cp $(CURDIR)/padthv1.1 $(CURDIR)/padthv1_jack.1
	cp $(CURDIR)/padthv1.fr.1 $(CURDIR)/padthv1_jack.fr.1
	dh_auto_install
	cp $(CURDIR)/debian/tmp/usr/share/mime/packages/padthv1.xml $(CURDIR)/debian/padthv1-common.sharedmimeinfo

override_dh_clean:
	dh_clean
	rm -f $(CURDIR)/debian/padthv1-common.sharedmimeinfo
	rm -f $(CURDIR)/padthv1_jack.1
	rm -f $(CURDIR)/padthv1_jack.fr.1

## padthv1 0.9.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required (VERSION 3.15)
 
 project (padthv1
-  VERSION 0.9.24
+  VERSION 0.9.26
   DESCRIPTION "an old-school polyphonic additive synthesizer"
   LANGUAGES C CXX)
 
@@ -108,6 +108,8 @@
 # Enable NSM support.
 option (CONFIG_NSM "Enable NSM support (default=yes)" 1)
 
+# Enable Wayland support option.
+option (CONFIG_WAYLAND "Enable Wayland support (EXPERIMENTAL) (default=no)" 0)
 
 # Enable Qt6 build preference.
 option (CONFIG_QT6 "Enable Qt6 build (default=yes)" 1)
@@ -139,7 +141,7 @@
   find_package (QT QUIET NAMES Qt5)
 endif ()
 
-find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
+find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml Svg)
 
 #find_package (Qt${QT_VERSION_MAJOR}LinguistTools)
 
@@ -310,10 +312,10 @@
 add_subdirectory (src)
 
 
-configure_file (padthv1.spec.in padthv1.spec IMMEDIATE @ONLY)
-
-install (FILES padthv1.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
-install (FILES padthv1.fr.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME padthv1.1)
+if (UNIX AND NOT APPLE)
+  configure_file (${PROJECT_NAME}.spec.in ${PROJECT_NAME}.spec IMMEDIATE @ONLY)
+endif ()
+
 
 # Configuration status
 macro (SHOW_OPTION text value)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -153,13 +153,22 @@
 endif ()
 
 # Add some debugger flags.
-if (CONFIG_DEBUG AND CONFIG_JACK AND UNIX AND NOT APPLE)
-  target_compile_options (${PROJECT_NAME}_jack PRIVATE -g -fsanitize=address -fno-omit-frame-pointer)
-  target_link_libraries (${PROJECT_NAME}_jack PRIVATE asan)
+if (CONFIG_DEBUG AND UNIX AND NOT APPLE)
+  set (CONFIG_DEBUG_OPTIONS -g -fsanitize=address -fno-omit-frame-pointer)
+  target_compile_options (${PROJECT_NAME} PRIVATE ${CONFIG_DEBUG_OPTIONS})
+  target_compile_options (${PROJECT_NAME}_ui PRIVATE ${CONFIG_DEBUG_OPTIONS})
+  if (CONFIG_LV2)
+    target_compile_options (${PROJECT_NAME}_lv2 PRIVATE ${CONFIG_DEBUG_OPTIONS})
+    target_link_options (${PROJECT_NAME}_lv2 PRIVATE ${CONFIG_DEBUG_OPTIONS})
+  endif ()
+  if (CONFIG_JACK)
+    target_compile_options (${PROJECT_NAME}_jack PRIVATE ${CONFIG_DEBUG_OPTIONS})
+    target_link_options (${PROJECT_NAME}_jack PRIVATE ${CONFIG_DEBUG_OPTIONS})
+  endif ()
 endif ()
 
 target_link_libraries (${PROJECT_NAME}    PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Xml)
-target_link_libraries (${PROJECT_NAME}_ui PUBLIC Qt${QT_VERSION_MAJOR}::Widgets ${PROJECT_NAME})
+target_link_libraries (${PROJECT_NAME}_ui PUBLIC Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg ${PROJECT_NAME})
 
 if (CONFIG_FFTW3)
   target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::FFTW3)
@@ -227,19 +236,25 @@
     endif ()
     install (TARGETS ${PROJECT_NAME}_jack RUNTIME
       DESTINATION ${CMAKE_INSTALL_BINDIR})
-    install (FILES org.rncbc.${PROJECT_NAME}.desktop
-      DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
     install (FILES images/${PROJECT_NAME}.png
+      RENAME org.rncbc.${PROJECT_NAME}.png
       DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
     install (FILES images/${PROJECT_NAME}.svg
+      RENAME org.rncbc.${PROJECT_NAME}.svg
       DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-    install (FILES appdata/org.rncbc.${PROJECT_NAME}.xml
+    install (FILES appdata/org.rncbc.${PROJECT_NAME}.desktop
+      DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
+    install (FILES appdata/org.rncbc.${PROJECT_NAME}.metainfo.xml
       DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
-    install (FILES mimetypes/${PROJECT_NAME}.xml
+    install (FILES mimetypes/org.rncbc.${PROJECT_NAME}.xml
       DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)
-    install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.png
+    install (FILES mimetypes/org.rncbc.${PROJECT_NAME}.application-x-${PROJECT_NAME}-preset.png
       DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/mimetypes)
-    install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.svg
+    install (FILES mimetypes/org.rncbc.${PROJECT_NAME}.application-x-${PROJECT_NAME}-preset.svg
       DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/mimetypes)
-  endif ()
-endif ()
+    install (FILES man1/${PROJECT_NAME}.1
+      DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
+    install (FILES man1/${PROJECT_NAME}.fr.1
+      DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME ${PROJECT_NAME}.1)
+  endif ()
+endif ()

=== debian/changelog ===
padthv1 (0.9.26-1) unstable; urgency=medium

  * New upstream version 0.9.26
  * Use libjack-jackd2-dev as preferable B-D and libjack-dev as optional
  * Add libqt5svg5-dev as B-D and sort B-Ds
  * Bump Standards Version to 4.6.1

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 08 Jun 2022 17:04:00 +0200

padthv1 (0.9.25-1) unstable; urgency=medium

  * New upstream version 0.9.25
  * Update paths to manpages and rename appdata and mime file

 -- Dennis Braun <d_braun@kabelmail.de>  Fri, 15 Apr 2022 23:06:21 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,26 @@
 Source: padthv1
 Section: sound
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Dennis Braun <d_braun@kabelmail.de>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ ladspa-sdk,
+ libasound2-dev,
+ libfftw3-dev,
+ libjack-jackd2-dev | libjack-dev,
+ liblo-dev,
+ libqt5svg5-dev,
+ libsndfile1-dev,
  libx11-dev,
+ lv2-dev,
  qtbase5-dev,
  qttools5-dev-tools,
- ladspa-sdk,
- lv2-dev,
- libsndfile1-dev,
- libasound2-dev,
- libjack-dev | libjack-jackd2-dev,
- libfftw3-dev,
- liblo-dev,
 Homepage: https://padthv1.sourceforge.io/
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/multimedia-team/padthv1.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/padthv1
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH_OS),linux)
 CMAKE_OPTS = -DCONFIG_ALSA_MIDI=ON
else
 CMAKE_OPTS = -DCONFIG_ALSA_MIDI=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_install:
	cp $(CURDIR)/src/man1/padthv1.1 $(CURDIR)/src/man1/padthv1_jack.1
	cp $(CURDIR)/src/man1/padthv1.fr.1 $(CURDIR)/src/man1/padthv1_jack.fr.1
	dh_auto_install
	cp $(CURDIR)/debian/tmp/usr/share/mime/packages/org.rncbc.padthv1.xml $(CURDIR)/debian/padthv1-common.sharedmimeinfo

override_dh_clean:
	dh_clean
	rm -f $(CURDIR)/debian/padthv1-common.sharedmimeinfo
	rm -f $(CURDIR)/src/man1/padthv1_jack.1
	rm -f $(CURDIR)/src/man1/padthv1_jack.fr.1

## padthv1 0.9.29

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required (VERSION 3.15)
 
 project (padthv1
-  VERSION 0.9.26
+  VERSION 0.9.29
   DESCRIPTION "an old-school polyphonic additive synthesizer"
   LANGUAGES C CXX)
 
@@ -38,21 +38,15 @@
 set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
 set (PACKAGE_TARNAME "padthv1")
 
-set (ac_version "${PROJECT_VERSION}")
-set (ac_prefix "${CMAKE_INSTALL_PREFIX}")
-
 set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")
 
-if (CONFIG_DEBUG)
-  set (CMAKE_BUILD_TYPE "Debug")
-endif ()
 if (CMAKE_BUILD_TYPE MATCHES "Debug")
   set (CONFIG_DEBUG 1)
-endif ()
-if (CONFIG_DEBUG)
   set (CONFIG_BUILD_TYPE "debug")
 else ()
+  set (CONFIG_DEBUG 0)
   set (CONFIG_BUILD_TYPE "release")
+  set (CMAKE_BUILD_TYPE "Release")
 endif ()
 
 set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")
@@ -99,7 +93,7 @@
 
 option (CONFIG_LV2_PATCH "Enable LV2 plug-in Patch support (default=yes)" 1)
 
-option (CONFIG_LV2_PORT_EVENT "Enable LV2 plug-in Port-event support (EXPERIMENTAL) (default=yes)" 1)
+option (CONFIG_LV2_PORT_EVENT "Enable LV2 plug-in Port-event support (default=yes)" 1)
 
 
 # Enable liblo availability.
@@ -312,11 +306,6 @@
 add_subdirectory (src)
 
 
-if (UNIX AND NOT APPLE)
-  configure_file (${PROJECT_NAME}.spec.in ${PROJECT_NAME}.spec IMMEDIATE @ONLY)
-endif ()
-
-
 # Configuration status
 macro (SHOW_OPTION text value)
   if (${value})
@@ -345,7 +334,7 @@
 show_option ("  LV2 plug-in UI Resize interface support  . . . . ." CONFIG_LV2_UI_RESIZE)
 show_option ("  LV2 plug-in Programs support . . . . . . . . . . ." CONFIG_LV2_PROGRAMS)
 show_option ("  LV2 plug-in Patch support  . . . . . . . . . . . ." CONFIG_LV2_PATCH)
-show_option ("  LV2 plug-in Port-event support (EXPERIMENTAL)  . ." CONFIG_LV2_PORT_EVENT)
+show_option ("  LV2 plug-in Port-event support . . . . . . . . . ." CONFIG_LV2_PORT_EVENT)
 show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)
 show_option ("  Non Session Management (NSM) support . . . . . . ." CONFIG_NSM)
 message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}\n")

=== debian/changelog ===
padthv1 (0.9.29-1) unstable; urgency=medium

  * New upstream version 0.9.29
  * Bump d/copyright years
  * Refresh patchset

 -- Dennis Braun <snd@debian.org>  Sun, 29 Jan 2023 16:31:19 +0100

padthv1 (0.9.28-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Defer stripping to dh_strip. (Closes: #1024419)

  [ Dennis Braun ]
  * New upstream version 0.9.28
  * Change my email address
  * Bump Standards-Version to 4.6.2

 -- Dennis Braun <snd@debian.org>  Fri, 30 Dec 2022 16:11:44 +0100

padthv1 (0.9.27-1) unstable; urgency=medium

  * New upstream version 0.9.27
  * Build with Qt6
  * Prefer libjack-dev over libjack-jackd2-dev
  * d/tests: No more start and kill, thanks bunk! (Closes: #1016939)
  * Add salsa ci config

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 06 Oct 2022 23:08:34 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
- Dennis Braun <d_braun@kabelmail.de>,
+ Dennis Braun <snd@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
  cmake,
@@ -11,16 +11,16 @@
  ladspa-sdk,
  libasound2-dev,
  libfftw3-dev,
- libjack-jackd2-dev | libjack-dev,
+ libjack-dev | libjack-jackd2-dev,
  liblo-dev,
- libqt5svg5-dev,
+ libqt6svg6-dev,
  libsndfile1-dev,
  libx11-dev,
  lv2-dev,
- qtbase5-dev,
- qttools5-dev-tools,
+ qt6-base-dev,
+ qt6-tools-dev-tools
 Homepage: https://padthv1.sourceforge.io/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/multimedia-team/padthv1.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/padthv1
 Rules-Requires-Root: no

## padthv1 0.9.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required (VERSION 3.15)
 
 project (padthv1
-  VERSION 0.9.29
+  VERSION 0.9.31
   DESCRIPTION "an old-school polyphonic additive synthesizer"
   LANGUAGES C CXX)

=== debian/changelog ===
padthv1 (0.9.31-1) unstable; urgency=medium

  * New upstream version 0.9.31

 -- Dennis Braun <snd@debian.org>  Tue, 20 Jun 2023 12:57:08 +0200

## padthv1 0.9.34

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,14 @@
 cmake_minimum_required (VERSION 3.15)
 
 project (padthv1
-  VERSION 0.9.31
+  VERSION 0.9.34
   DESCRIPTION "an old-school polyphonic additive synthesizer"
+  HOMEPAGE_URL "https://padthv1.sourceforge.io"
   LANGUAGES C CXX)
 
-set (CONFIG_VERSION ${PROJECT_VERSION})
+set (PROJECT_COPYRIGHT "Copyright (C) 2012-2024, rncbc aka Rui Nuno Capela. All rights reserved.")
+set (PROJECT_DOMAIN    "rncbc.org")
+
 execute_process (
   COMMAND git describe --tags --dirty --abbrev=6
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
@@ -13,32 +16,24 @@
   RESULT_VARIABLE GIT_DESCRIBE_RESULT
   OUTPUT_STRIP_TRAILING_WHITESPACE)
 if (GIT_DESCRIBE_RESULT EQUAL 0)
-  set (VERSION "${GIT_DESCRIBE_OUTPUT}")
-  string (REGEX REPLACE "^[^0-9]+" "" VERSION "${VERSION}")
-  string (REGEX REPLACE "^1_"      "" VERSION "${VERSION}")
-  string (REGEX REPLACE "^[_vV]+"  "" VERSION "${VERSION}")
-  string (REGEX REPLACE "-g"   "git." VERSION "${VERSION}")
-  string (REGEX REPLACE "[_|-]"   "." VERSION "${VERSION}")
+  set (GIT_VERSION "${GIT_DESCRIBE_OUTPUT}")
+  string (REGEX REPLACE "^[^0-9]+" "" GIT_VERSION "${GIT_VERSION}")
+  string (REGEX REPLACE "^1_"      "" GIT_VERSION "${GIT_VERSION}")
+  string (REGEX REPLACE "^[_vV]+"  "" GIT_VERSION "${GIT_VERSION}")
+  string (REGEX REPLACE "-g"   "git." GIT_VERSION "${GIT_VERSION}")
+  string (REGEX REPLACE "[_|-]"   "." GIT_VERSION "${GIT_VERSION}")
   execute_process (
     COMMAND git rev-parse --abbrev-ref HEAD
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
     OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
     RESULT_VARIABLE GIT_REVPARSE_RESULT
     OUTPUT_STRIP_TRAILING_WHITESPACE)
-  if (GIT_REVPARSE_RESULT EQUAL 0 AND NOT GIT_REVPARSE_OUTPUT STREQUAL "master")
-    set (VERSION "${VERSION} [${GIT_REVPARSE_OUTPUT}]")
-  endif ()
-else ()
-  set (VERSION "${PROJECT_VERSION}")
-endif ()
-
-set (PACKAGE_NAME "padthv1")
-set (PACKAGE_VERSION "${VERSION}")
-set (PACKAGE_BUGREPORT "rncbc@rncbc.org")
-set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
-set (PACKAGE_TARNAME "padthv1")
-
-set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")
+  if (GIT_REVPARSE_RESULT EQUAL 0 AND NOT GIT_REVPARSE_OUTPUT STREQUAL "main")
+    set (GIT_VERSION "${GIT_VERSION} [${GIT_REVPARSE_OUTPUT}]")
+  endif ()
+  set (PROJECT_VERSION "${GIT_VERSION}")
+endif ()
+
 
 if (CMAKE_BUILD_TYPE MATCHES "Debug")
   set (CONFIG_DEBUG 1)
@@ -94,6 +89,8 @@
 option (CONFIG_LV2_PATCH "Enable LV2 plug-in Patch support (default=yes)" 1)
 
 option (CONFIG_LV2_PORT_EVENT "Enable LV2 plug-in Port-event support (default=yes)" 1)
+
+option (CONFIG_LV2_PORT_CHANGE_REQUEST "Enable LV2 plug-in Port-change request support (default=yes)" 1)
 
 
 # Enable liblo availability.
@@ -234,33 +231,56 @@
   pkg_check_modules (LV2 lv2)
   if (LV2_FOUND)
     include_directories (${LV2_INCLUDE_DIRS})
-    # Check for LV2 Atom support.
+    # Check for LV2 old/new headers style.
+    check_include_file (lv2/urid/urid.h HAVE_LV2_URID_H)
+    if (NOT HAVE_LV2_URID_H)
+      check_include_file (lv2/lv2plug.in/ns/ext/urid/urid.h HAVE_OLD_LV2_URID_H)
+      if (NOT HAVE_OLD_LV2_URID_H)
+        set (CONFIG_LV2 0)
+      else ()
+        set (CONFIG_LV2_OLD_HEADERS 1)
+      endif ()
+    else ()
+      set (CONFIG_LV2_OLD_HEADERS 0)
+    endif ()
+  endif ()
+  if (NOT CONFIG_LV2)
+    message (WARNING "*** LV2 SDK not found.")
+  endif ()
+endif ()
+
+if (CONFIG_LV2)
+  # Check for LV2 Atom support.
+  if (CONFIG_LV2_OLD_HEADERS)
     check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
-    if (NOT HAVE_LV2_ATOM_H)
-      set (CONFIG_LV2_ATOM 0)
-    else ()
-      set (CONFIG_LV2_ATOM 1)
-    endif ()
-    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
-    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
-    # Check for LV2 UI support.
+  else ()
+    check_include_file (lv2/atom/atom.h HAVE_LV2_ATOM_H)
+  endif ()
+  if (NOT HAVE_LV2_ATOM_H)
+    set (CONFIG_LV2_ATOM 0)
+  else ()
+    set (CONFIG_LV2_ATOM 1)
+  endif ()
+  set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
+  set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
+  # Check for LV2 UI support.
+  if (CONFIG_LV2_OLD_HEADERS)
     check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
-    if (NOT HAVE_LV2_UI_H)
-      set (CONFIG_LV2_UI 0)
-    else ()
-      set (CONFIG_LV2_UI 1)
-    endif ()
-    if (NOT CONFIG_LV2_UI)
-      set (CONFIG_LV2_UI_X11 0)
-      set (CONFIG_LV2_UI_WINDOWS 0)
-      set (CONFIG_LV2_UI_EXTERNAL 0)
-      set (CONFIG_LV2_UI_IDLE 0)
-      set (CONFIG_LV2_UI_SHOW 0)
-      set (CONFIG_LV2_UI_RESIZE 0)
-    endif ()
-  else ()
-    message (WARNING "*** LV2 SDK not found.")
-    set (CONFIG_LV2 0)
+  else ()
+    check_include_file (lv2/ui/ui.h HAVE_LV2_UI_H)
+  endif ()
+  if (NOT HAVE_LV2_UI_H)
+    set (CONFIG_LV2_UI 0)
+  else ()
+    set (CONFIG_LV2_UI 1)
+  endif ()
+  if (NOT CONFIG_LV2_UI)
+    set (CONFIG_LV2_UI_X11 0)
+    set (CONFIG_LV2_UI_WINDOWS 0)
+    set (CONFIG_LV2_UI_EXTERNAL 0)
+    set (CONFIG_LV2_UI_IDLE 0)
+    set (CONFIG_LV2_UI_SHOW 0)
+    set (CONFIG_LV2_UI_RESIZE 0)
   endif ()
 endif ()
 
@@ -279,6 +299,7 @@
   set (CONFIG_LV2_PROGRAMS 0)
   set (CONFIG_LV2_PATCH 0)
   set (CONFIG_LV2_PORT_EVENT 0)
+  set (CONFIG_LV2_PORT_CHANGE_REQUEST 0)
 endif ()
 
 if (CONFIG_LV2_UI_EXTERNAL)
@@ -296,9 +317,20 @@
 endif ()
 
 if (CONFIG_LV2_PATCH)
-  check_include_file (lv2/lv2plug.in/ns/ext/patch/patch.h HAVE_LV2_PATCH_H)
+  if (CONFIG_LV2_OLD_HEADERS)
+    check_include_file (lv2/lv2plug.in/ns/ext/patch/patch.h HAVE_LV2_PATCH_H)
+  else ()
+    check_include_file (lv2/patch/patch.h HAVE_LV2_PATCH_H)
+ endif ()
   if (NOT HAVE_LV2_PATCH_H)
     set (CONFIG_LV2_PATCH 0)
+  endif ()
+endif ()
+
+if (CONFIG_LV2_PORT_CHANGE_REQUEST)
+  check_include_file (lv2_port_change_request.h HAVE_LV2_PORT_CHANGE_REQUEST_H)
+  if (NOT HAVE_LV2_PORT_CHANGE_REQUEST_H)
+    set (CONFIG_LV2_PORT_CHANGE_REQUEST 0)
   endif ()
 endif ()
 
@@ -315,8 +347,7 @@
   endif ()
 endmacro ()
 
-
-message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION} (Qt ${QT_VERSION})")
+message   ("\n  ${PROJECT_NAME} ${PROJECT_VERSION} (Qt ${QT_VERSION})")
 message   ("\n  Build target . . . . . . . . . . . . . . . . . . .: ${CONFIG_BUILD_TYPE}\n")
 show_option ("  JACK stand-alone build . . . . . . . . . . . . . ." CONFIG_JACK)
 show_option ("  JACK session support . . . . . . . . . . . . . . ." CONFIG_JACK_SESSION)
@@ -335,6 +366,5 @@
 show_option ("  LV2 plug-in Programs support . . . . . . . . . . ." CONFIG_LV2_PROGRAMS)
 show_option ("  LV2 plug-in Patch support  . . . . . . . . . . . ." CONFIG_LV2_PATCH)
 show_option ("  LV2 plug-in Port-event support . . . . . . . . . ." CONFIG_LV2_PORT_EVENT)
+show_option ("  LV2 plug-in Port-change request (EXPERIMENTAL) . ." CONFIG_LV2_PORT_CHANGE_REQUEST)
 show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)
-show_option ("  Non Session Management (NSM) support . . . . . . ." CONFIG_NSM)
-message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}\n")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -155,12 +155,12 @@
 # Add some debugger flags.
 if (CONFIG_DEBUG AND UNIX AND NOT APPLE)
   set (CONFIG_DEBUG_OPTIONS -g -fsanitize=address -fno-omit-frame-pointer)
-  target_compile_options (${PROJECT_NAME} PRIVATE ${CONFIG_DEBUG_OPTIONS})
-  target_compile_options (${PROJECT_NAME}_ui PRIVATE ${CONFIG_DEBUG_OPTIONS})
-  if (CONFIG_LV2)
-    target_compile_options (${PROJECT_NAME}_lv2 PRIVATE ${CONFIG_DEBUG_OPTIONS})
-    target_link_options (${PROJECT_NAME}_lv2 PRIVATE ${CONFIG_DEBUG_OPTIONS})
-  endif ()
+# target_compile_options (${PROJECT_NAME} PRIVATE ${CONFIG_DEBUG_OPTIONS})
+# target_compile_options (${PROJECT_NAME}_ui PRIVATE ${CONFIG_DEBUG_OPTIONS})
+# if (CONFIG_LV2)
+#   target_compile_options (${PROJECT_NAME}_lv2 PRIVATE ${CONFIG_DEBUG_OPTIONS})
+#   target_link_options (${PROJECT_NAME}_lv2 PRIVATE ${CONFIG_DEBUG_OPTIONS})
+# endif ()
   if (CONFIG_JACK)
     target_compile_options (${PROJECT_NAME}_jack PRIVATE ${CONFIG_DEBUG_OPTIONS})
     target_link_options (${PROJECT_NAME}_jack PRIVATE ${CONFIG_DEBUG_OPTIONS})

=== debian/changelog ===
padthv1 (0.9.34-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:20:37 +0000

padthv1 (0.9.34-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 09:24:13 +0000

padthv1 (0.9.34-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:54:45 +0000

padthv1 (0.9.34-1) unstable; urgency=medium

  * New upstream version 0.9.34
  * Bump d/copyright years

 -- Dennis Braun <snd@debian.org>  Thu, 01 Feb 2024 21:29:56 +0100

padthv1 (0.9.33-1) unstable; urgency=medium

  * New upstream version 0.9.33

 -- Dennis Braun <snd@debian.org>  Fri, 22 Dec 2023 22:45:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: padthv1
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Dennis Braun <snd@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>

## padthv1 0.9.90

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required (VERSION 3.15)
 
 project (padthv1
-  VERSION 0.9.34
+  VERSION 0.9.90
   DESCRIPTION "an old-school polyphonic additive synthesizer"
   HOMEPAGE_URL "https://padthv1.sourceforge.io"
   LANGUAGES C CXX)
@@ -289,6 +289,9 @@
   set (LV2_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/lv2)
   set (CMAKE_REQUIRED_INCLUDES "${LV2_INCLUDES};${CMAKE_REQUIRED_INCLUDES}")
   include_directories (${LV2_INCLUDES})
+  if (CONFIG_LV2_OLD_HEADERS)
+    set (CMAKE_REQUIRED_DEFINITIONS "-DCONFIG_LV2_OLD_HEADERS;${CMAKE_REQUIRED_DEFINITIONS}")
+  endif ()
 else ()
   set (CONFIG_LV2_UI_X11 0)
   set (CONFIG_LV2_UI_WINDOWS 0)
@@ -366,5 +369,3 @@
 show_option ("  LV2 plug-in Programs support . . . . . . . . . . ." CONFIG_LV2_PROGRAMS)
 show_option ("  LV2 plug-in Patch support  . . . . . . . . . . . ." CONFIG_LV2_PATCH)
 show_option ("  LV2 plug-in Port-event support . . . . . . . . . ." CONFIG_LV2_PORT_EVENT)
-show_option ("  LV2 plug-in Port-change request (EXPERIMENTAL) . ." CONFIG_LV2_PORT_CHANGE_REQUEST)
-show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)

=== debian/changelog ===
padthv1 (0.9.90-1build1) oracular; urgency=medium

  * Rebuild against new no t64 renamed libqt6 libraries.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Jun 2024 09:33:27 +0200

padthv1 (0.9.90-1) unstable; urgency=medium

  * New upstream version 0.9.90
  * Install custom color themes
  * Use the default ci config from salsa

 -- Dennis Braun <snd@debian.org>  Fri, 19 Apr 2024 18:26:22 +0200
